
#include "utils.bas"
#include "file.bi"

const FBEAUTY = "c:\outils\formatters\fbeauty\fbeauty.exe"
const OPTION_UPCASE = ""
const OPTION_LOWCASE = "-l"
const OPTION_CAPITALIZED = "-c"
const OPTION_INDIVIDUAL = "-i"
const MY_OPTION = OPTION_LOWCASE

declare sub BeautifyFile(byval aFilter as string, byval aPath as string, byval aOption as string)
declare sub BeautifyDirectory(byval aFilter as string, byval aPath as string, byval aOption as string)

if FileExists(FBEAUTY) andalso Len(Command(1)) then
  if DirExists(Command(1)) then
    BeautifyDirectory(FBEAUTY, Command(1) & "\", MY_OPTION)
  elseif FileExists(Command(1)) then
    BeautifyFile(FBEAUTY, Command(1), MY_OPTION)
  end if
end if

sub GenerateFile(byval aSource as string, byval aNewFile as string, byval aFilter as string, byval aOption as string)
  dim s as string
  dim as uinteger f1, f2
  f1 = FreeFile()
  open aNewFile for output as #f1
  f2 = FreeFile()
  open pipe aFilter & " " & aOption & " < " & aSource for input as #f2
  do until Eof(f2)
    line input #f2, s
    print #f1, s
  loop
  close #f2
  close #f1
end sub

sub BeautifyFile(byval aFilter as string, byval aPath as string, byval aOption as string)
  const BAS = ".bas"
  const TEMP = ".temp"
  Name(aPath, ChangeFileExt(aPath, TEMP))
  GenerateFile(ChangeFileExt(aPath, TEMP), aPath, aFilter, aOption)
  Kill(ChangeFileExt(aPath, TEMP))
end sub

sub BeautifyDirectory(byval aFilter as string, byval aPath as string, byval aOption as string)
  const BAS = ".bas"
  const TEMP = ".temp"
  dim a() as string
  ReplaceExt(aPath, BAS, TEMP)
  GetExt(aPath, TEMP, a())
  for i as integer = LBound(a) to UBound(a)
    GenerateFile(aPath & a(i), aPath & ChangeFileExt(a(i), BAS), aFilter, aOption)
  next i
  DeleteExt(aPath, TEMP)
end sub
